//#line 2 "/opt/ros/noetic/share/dynamic_reconfigure/cmake/../templates/ConfigType.h.template"
// *********************************************************
//
// File autogenerated for the beluga_amcl package
// by the dynamic_reconfigure package.
// Please do not edit.
//
// ********************************************************/

#ifndef __beluga_amcl__AMCLCONFIG_H__
#define __beluga_amcl__AMCLCONFIG_H__

#if __cplusplus >= 201103L
#define DYNAMIC_RECONFIGURE_FINAL final
#else
#define DYNAMIC_RECONFIGURE_FINAL
#endif

#include <dynamic_reconfigure/config_tools.h>
#include <limits>
#include <ros/node_handle.h>
#include <dynamic_reconfigure/ConfigDescription.h>
#include <dynamic_reconfigure/ParamDescription.h>
#include <dynamic_reconfigure/Group.h>
#include <dynamic_reconfigure/config_init_mutex.h>
#include <boost/any.hpp>

namespace beluga_amcl
{
  class AmclConfigStatics;

  class AmclConfig
  {
  public:
    class AbstractParamDescription : public dynamic_reconfigure::ParamDescription
    {
    public:
      AbstractParamDescription(std::string n, std::string t, uint32_t l,
          std::string d, std::string e)
      {
        name = n;
        type = t;
        level = l;
        description = d;
        edit_method = e;
      }
      virtual ~AbstractParamDescription() = default;

      virtual void clamp(AmclConfig &config, const AmclConfig &max, const AmclConfig &min) const = 0;
      virtual void calcLevel(uint32_t &level, const AmclConfig &config1, const AmclConfig &config2) const = 0;
      virtual void fromServer(const ros::NodeHandle &nh, AmclConfig &config) const = 0;
      virtual void toServer(const ros::NodeHandle &nh, const AmclConfig &config) const = 0;
      virtual bool fromMessage(const dynamic_reconfigure::Config &msg, AmclConfig &config) const = 0;
      virtual void toMessage(dynamic_reconfigure::Config &msg, const AmclConfig &config) const = 0;
      virtual void getValue(const AmclConfig &config, boost::any &val) const = 0;
    };

    typedef boost::shared_ptr<AbstractParamDescription> AbstractParamDescriptionPtr;
    typedef boost::shared_ptr<const AbstractParamDescription> AbstractParamDescriptionConstPtr;

    // Final keyword added to class because it has virtual methods and inherits
    // from a class with a non-virtual destructor.
    template <class T>
    class ParamDescription DYNAMIC_RECONFIGURE_FINAL : public AbstractParamDescription
    {
    public:
      ParamDescription(std::string a_name, std::string a_type, uint32_t a_level,
          std::string a_description, std::string a_edit_method, T AmclConfig::* a_f) :
        AbstractParamDescription(a_name, a_type, a_level, a_description, a_edit_method),
        field(a_f)
      {}

      T AmclConfig::* field;

      virtual void clamp(AmclConfig &config, const AmclConfig &max, const AmclConfig &min) const override
      {
        if (config.*field > max.*field)
          config.*field = max.*field;

        if (config.*field < min.*field)
          config.*field = min.*field;
      }

      virtual void calcLevel(uint32_t &comb_level, const AmclConfig &config1, const AmclConfig &config2) const override
      {
        if (config1.*field != config2.*field)
          comb_level |= level;
      }

      virtual void fromServer(const ros::NodeHandle &nh, AmclConfig &config) const override
      {
        nh.getParam(name, config.*field);
      }

      virtual void toServer(const ros::NodeHandle &nh, const AmclConfig &config) const override
      {
        nh.setParam(name, config.*field);
      }

      virtual bool fromMessage(const dynamic_reconfigure::Config &msg, AmclConfig &config) const override
      {
        return dynamic_reconfigure::ConfigTools::getParameter(msg, name, config.*field);
      }

      virtual void toMessage(dynamic_reconfigure::Config &msg, const AmclConfig &config) const override
      {
        dynamic_reconfigure::ConfigTools::appendParameter(msg, name, config.*field);
      }

      virtual void getValue(const AmclConfig &config, boost::any &val) const override
      {
        val = config.*field;
      }
    };

    class AbstractGroupDescription : public dynamic_reconfigure::Group
    {
      public:
      AbstractGroupDescription(std::string n, std::string t, int p, int i, bool s)
      {
        name = n;
        type = t;
        parent = p;
        state = s;
        id = i;
      }

      virtual ~AbstractGroupDescription() = default;

      std::vector<AbstractParamDescriptionConstPtr> abstract_parameters;
      bool state;

      virtual void toMessage(dynamic_reconfigure::Config &msg, const boost::any &config) const = 0;
      virtual bool fromMessage(const dynamic_reconfigure::Config &msg, boost::any &config) const =0;
      virtual void updateParams(boost::any &cfg, AmclConfig &top) const= 0;
      virtual void setInitialState(boost::any &cfg) const = 0;


      void convertParams()
      {
        for(std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = abstract_parameters.begin(); i != abstract_parameters.end(); ++i)
        {
          parameters.push_back(dynamic_reconfigure::ParamDescription(**i));
        }
      }
    };

    typedef boost::shared_ptr<AbstractGroupDescription> AbstractGroupDescriptionPtr;
    typedef boost::shared_ptr<const AbstractGroupDescription> AbstractGroupDescriptionConstPtr;

    // Final keyword added to class because it has virtual methods and inherits
    // from a class with a non-virtual destructor.
    template<class T, class PT>
    class GroupDescription DYNAMIC_RECONFIGURE_FINAL : public AbstractGroupDescription
    {
    public:
      GroupDescription(std::string a_name, std::string a_type, int a_parent, int a_id, bool a_s, T PT::* a_f) : AbstractGroupDescription(a_name, a_type, a_parent, a_id, a_s), field(a_f)
      {
      }

      GroupDescription(const GroupDescription<T, PT>& g): AbstractGroupDescription(g.name, g.type, g.parent, g.id, g.state), field(g.field), groups(g.groups)
      {
        parameters = g.parameters;
        abstract_parameters = g.abstract_parameters;
      }

      virtual bool fromMessage(const dynamic_reconfigure::Config &msg, boost::any &cfg) const override
      {
        PT* config = boost::any_cast<PT*>(cfg);
        if(!dynamic_reconfigure::ConfigTools::getGroupState(msg, name, (*config).*field))
          return false;

        for(std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = groups.begin(); i != groups.end(); ++i)
        {
          boost::any n = &((*config).*field);
          if(!(*i)->fromMessage(msg, n))
            return false;
        }

        return true;
      }

      virtual void setInitialState(boost::any &cfg) const override
      {
        PT* config = boost::any_cast<PT*>(cfg);
        T* group = &((*config).*field);
        group->state = state;

        for(std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = groups.begin(); i != groups.end(); ++i)
        {
          boost::any n = boost::any(&((*config).*field));
          (*i)->setInitialState(n);
        }

      }

      virtual void updateParams(boost::any &cfg, AmclConfig &top) const override
      {
        PT* config = boost::any_cast<PT*>(cfg);

        T* f = &((*config).*field);
        f->setParams(top, abstract_parameters);

        for(std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = groups.begin(); i != groups.end(); ++i)
        {
          boost::any n = &((*config).*field);
          (*i)->updateParams(n, top);
        }
      }

      virtual void toMessage(dynamic_reconfigure::Config &msg, const boost::any &cfg) const override
      {
        const PT config = boost::any_cast<PT>(cfg);
        dynamic_reconfigure::ConfigTools::appendGroup<T>(msg, name, id, parent, config.*field);

        for(std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = groups.begin(); i != groups.end(); ++i)
        {
          (*i)->toMessage(msg, config.*field);
        }
      }

      T PT::* field;
      std::vector<AmclConfig::AbstractGroupDescriptionConstPtr> groups;
    };

class DEFAULT
{
  public:
    DEFAULT()
    {
      state = true;
      name = "Default";
    }

    void setParams(AmclConfig &config, const std::vector<AbstractParamDescriptionConstPtr> params)
    {
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator _i = params.begin(); _i != params.end(); ++_i)
      {
        boost::any val;
        (*_i)->getValue(config, val);

        if("global_frame_id"==(*_i)->name){global_frame_id = boost::any_cast<std::string>(val);}
        if("odom_frame_id"==(*_i)->name){odom_frame_id = boost::any_cast<std::string>(val);}
        if("base_frame_id"==(*_i)->name){base_frame_id = boost::any_cast<std::string>(val);}
        if("map_topic"==(*_i)->name){map_topic = boost::any_cast<std::string>(val);}
        if("map_service"==(*_i)->name){map_service = boost::any_cast<std::string>(val);}
        if("use_map_topic"==(*_i)->name){use_map_topic = boost::any_cast<bool>(val);}
        if("initial_pose_topic"==(*_i)->name){initial_pose_topic = boost::any_cast<std::string>(val);}
        if("scan_topic"==(*_i)->name){scan_topic = boost::any_cast<std::string>(val);}
        if("min_particles"==(*_i)->name){min_particles = boost::any_cast<int>(val);}
        if("max_particles"==(*_i)->name){max_particles = boost::any_cast<int>(val);}
        if("recovery_alpha_slow"==(*_i)->name){recovery_alpha_slow = boost::any_cast<double>(val);}
        if("recovery_alpha_fast"==(*_i)->name){recovery_alpha_fast = boost::any_cast<double>(val);}
        if("kld_err"==(*_i)->name){kld_err = boost::any_cast<double>(val);}
        if("kld_z"==(*_i)->name){kld_z = boost::any_cast<double>(val);}
        if("spatial_resolution_x"==(*_i)->name){spatial_resolution_x = boost::any_cast<double>(val);}
        if("spatial_resolution_y"==(*_i)->name){spatial_resolution_y = boost::any_cast<double>(val);}
        if("spatial_resolution_theta"==(*_i)->name){spatial_resolution_theta = boost::any_cast<double>(val);}
        if("resample_interval"==(*_i)->name){resample_interval = boost::any_cast<int>(val);}
        if("selective_resampling"==(*_i)->name){selective_resampling = boost::any_cast<bool>(val);}
        if("tf_broadcast"==(*_i)->name){tf_broadcast = boost::any_cast<bool>(val);}
        if("transform_tolerance"==(*_i)->name){transform_tolerance = boost::any_cast<double>(val);}
        if("odom_model_type"==(*_i)->name){odom_model_type = boost::any_cast<std::string>(val);}
        if("odom_alpha1"==(*_i)->name){odom_alpha1 = boost::any_cast<double>(val);}
        if("odom_alpha2"==(*_i)->name){odom_alpha2 = boost::any_cast<double>(val);}
        if("odom_alpha3"==(*_i)->name){odom_alpha3 = boost::any_cast<double>(val);}
        if("odom_alpha4"==(*_i)->name){odom_alpha4 = boost::any_cast<double>(val);}
        if("odom_alpha5"==(*_i)->name){odom_alpha5 = boost::any_cast<double>(val);}
        if("update_min_a"==(*_i)->name){update_min_a = boost::any_cast<double>(val);}
        if("update_min_d"==(*_i)->name){update_min_d = boost::any_cast<double>(val);}
        if("laser_model_type"==(*_i)->name){laser_model_type = boost::any_cast<std::string>(val);}
        if("laser_likelihood_max_dist"==(*_i)->name){laser_likelihood_max_dist = boost::any_cast<double>(val);}
        if("laser_max_range"==(*_i)->name){laser_max_range = boost::any_cast<double>(val);}
        if("laser_min_range"==(*_i)->name){laser_min_range = boost::any_cast<double>(val);}
        if("laser_max_beams"==(*_i)->name){laser_max_beams = boost::any_cast<int>(val);}
        if("laser_z_hit"==(*_i)->name){laser_z_hit = boost::any_cast<double>(val);}
        if("laser_z_rand"==(*_i)->name){laser_z_rand = boost::any_cast<double>(val);}
        if("laser_z_max"==(*_i)->name){laser_z_max = boost::any_cast<double>(val);}
        if("laser_z_short"==(*_i)->name){laser_z_short = boost::any_cast<double>(val);}
        if("laser_lambda_short"==(*_i)->name){laser_lambda_short = boost::any_cast<double>(val);}
        if("laser_sigma_hit"==(*_i)->name){laser_sigma_hit = boost::any_cast<double>(val);}
        if("always_reset_initial_pose"==(*_i)->name){always_reset_initial_pose = boost::any_cast<bool>(val);}
        if("first_map_only"==(*_i)->name){first_map_only = boost::any_cast<bool>(val);}
        if("set_initial_pose"==(*_i)->name){set_initial_pose = boost::any_cast<bool>(val);}
        if("initial_pose_x"==(*_i)->name){initial_pose_x = boost::any_cast<double>(val);}
        if("initial_pose_y"==(*_i)->name){initial_pose_y = boost::any_cast<double>(val);}
        if("initial_pose_a"==(*_i)->name){initial_pose_a = boost::any_cast<double>(val);}
        if("initial_cov_xx"==(*_i)->name){initial_cov_xx = boost::any_cast<double>(val);}
        if("initial_cov_yy"==(*_i)->name){initial_cov_yy = boost::any_cast<double>(val);}
        if("initial_cov_aa"==(*_i)->name){initial_cov_aa = boost::any_cast<double>(val);}
        if("initial_cov_xy"==(*_i)->name){initial_cov_xy = boost::any_cast<double>(val);}
        if("initial_cov_xa"==(*_i)->name){initial_cov_xa = boost::any_cast<double>(val);}
        if("initial_cov_ya"==(*_i)->name){initial_cov_ya = boost::any_cast<double>(val);}
        if("save_pose_rate"==(*_i)->name){save_pose_rate = boost::any_cast<double>(val);}
        if("execution_policy"==(*_i)->name){execution_policy = boost::any_cast<std::string>(val);}
        if("std_warn_level_x"==(*_i)->name){std_warn_level_x = boost::any_cast<double>(val);}
        if("std_warn_level_y"==(*_i)->name){std_warn_level_y = boost::any_cast<double>(val);}
        if("std_warn_level_yaw"==(*_i)->name){std_warn_level_yaw = boost::any_cast<double>(val);}
        if("restore_defaults"==(*_i)->name){restore_defaults = boost::any_cast<bool>(val);}
      }
    }

    std::string global_frame_id;
std::string odom_frame_id;
std::string base_frame_id;
std::string map_topic;
std::string map_service;
bool use_map_topic;
std::string initial_pose_topic;
std::string scan_topic;
int min_particles;
int max_particles;
double recovery_alpha_slow;
double recovery_alpha_fast;
double kld_err;
double kld_z;
double spatial_resolution_x;
double spatial_resolution_y;
double spatial_resolution_theta;
int resample_interval;
bool selective_resampling;
bool tf_broadcast;
double transform_tolerance;
std::string odom_model_type;
double odom_alpha1;
double odom_alpha2;
double odom_alpha3;
double odom_alpha4;
double odom_alpha5;
double update_min_a;
double update_min_d;
std::string laser_model_type;
double laser_likelihood_max_dist;
double laser_max_range;
double laser_min_range;
int laser_max_beams;
double laser_z_hit;
double laser_z_rand;
double laser_z_max;
double laser_z_short;
double laser_lambda_short;
double laser_sigma_hit;
bool always_reset_initial_pose;
bool first_map_only;
bool set_initial_pose;
double initial_pose_x;
double initial_pose_y;
double initial_pose_a;
double initial_cov_xx;
double initial_cov_yy;
double initial_cov_aa;
double initial_cov_xy;
double initial_cov_xa;
double initial_cov_ya;
double save_pose_rate;
std::string execution_policy;
double std_warn_level_x;
double std_warn_level_y;
double std_warn_level_yaw;
bool restore_defaults;

    bool state;
    std::string name;

    
}groups;



//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      std::string global_frame_id;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      std::string odom_frame_id;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      std::string base_frame_id;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      std::string map_topic;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      std::string map_service;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      bool use_map_topic;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      std::string initial_pose_topic;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      std::string scan_topic;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      int min_particles;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      int max_particles;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      double recovery_alpha_slow;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      double recovery_alpha_fast;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      double kld_err;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      double kld_z;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      double spatial_resolution_x;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      double spatial_resolution_y;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      double spatial_resolution_theta;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      int resample_interval;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      bool selective_resampling;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      bool tf_broadcast;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      double transform_tolerance;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      std::string odom_model_type;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      double odom_alpha1;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      double odom_alpha2;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      double odom_alpha3;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      double odom_alpha4;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      double odom_alpha5;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      double update_min_a;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      double update_min_d;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      std::string laser_model_type;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      double laser_likelihood_max_dist;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      double laser_max_range;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      double laser_min_range;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      int laser_max_beams;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      double laser_z_hit;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      double laser_z_rand;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      double laser_z_max;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      double laser_z_short;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      double laser_lambda_short;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      double laser_sigma_hit;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      bool always_reset_initial_pose;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      bool first_map_only;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      bool set_initial_pose;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      double initial_pose_x;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      double initial_pose_y;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      double initial_pose_a;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      double initial_cov_xx;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      double initial_cov_yy;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      double initial_cov_aa;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      double initial_cov_xy;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      double initial_cov_xa;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      double initial_cov_ya;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      double save_pose_rate;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      std::string execution_policy;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      double std_warn_level_x;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      double std_warn_level_y;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      double std_warn_level_yaw;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      bool restore_defaults;
//#line 231 "/opt/ros/noetic/share/dynamic_reconfigure/cmake/../templates/ConfigType.h.template"

    bool __fromMessage__(dynamic_reconfigure::Config &msg)
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      const std::vector<AbstractGroupDescriptionConstPtr> &__group_descriptions__ = __getGroupDescriptions__();

      int count = 0;
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); ++i)
        if ((*i)->fromMessage(msg, *this))
          count++;

      for (std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = __group_descriptions__.begin(); i != __group_descriptions__.end(); i ++)
      {
        if ((*i)->id == 0)
        {
          boost::any n = boost::any(this);
          (*i)->updateParams(n, *this);
          (*i)->fromMessage(msg, n);
        }
      }

      if (count != dynamic_reconfigure::ConfigTools::size(msg))
      {
        ROS_ERROR("AmclConfig::__fromMessage__ called with an unexpected parameter.");
        ROS_ERROR("Booleans:");
        for (unsigned int i = 0; i < msg.bools.size(); i++)
          ROS_ERROR("  %s", msg.bools[i].name.c_str());
        ROS_ERROR("Integers:");
        for (unsigned int i = 0; i < msg.ints.size(); i++)
          ROS_ERROR("  %s", msg.ints[i].name.c_str());
        ROS_ERROR("Doubles:");
        for (unsigned int i = 0; i < msg.doubles.size(); i++)
          ROS_ERROR("  %s", msg.doubles[i].name.c_str());
        ROS_ERROR("Strings:");
        for (unsigned int i = 0; i < msg.strs.size(); i++)
          ROS_ERROR("  %s", msg.strs[i].name.c_str());
        // @todo Check that there are no duplicates. Make this error more
        // explicit.
        return false;
      }
      return true;
    }

    // This version of __toMessage__ is used during initialization of
    // statics when __getParamDescriptions__ can't be called yet.
    void __toMessage__(dynamic_reconfigure::Config &msg, const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__, const std::vector<AbstractGroupDescriptionConstPtr> &__group_descriptions__) const
    {
      dynamic_reconfigure::ConfigTools::clear(msg);
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); ++i)
        (*i)->toMessage(msg, *this);

      for (std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = __group_descriptions__.begin(); i != __group_descriptions__.end(); ++i)
      {
        if((*i)->id == 0)
        {
          (*i)->toMessage(msg, *this);
        }
      }
    }

    void __toMessage__(dynamic_reconfigure::Config &msg) const
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      const std::vector<AbstractGroupDescriptionConstPtr> &__group_descriptions__ = __getGroupDescriptions__();
      __toMessage__(msg, __param_descriptions__, __group_descriptions__);
    }

    void __toServer__(const ros::NodeHandle &nh) const
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); ++i)
        (*i)->toServer(nh, *this);
    }

    void __fromServer__(const ros::NodeHandle &nh)
    {
      static bool setup=false;

      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); ++i)
        (*i)->fromServer(nh, *this);

      const std::vector<AbstractGroupDescriptionConstPtr> &__group_descriptions__ = __getGroupDescriptions__();
      for (std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = __group_descriptions__.begin(); i != __group_descriptions__.end(); i++){
        if (!setup && (*i)->id == 0) {
          setup = true;
          boost::any n = boost::any(this);
          (*i)->setInitialState(n);
        }
      }
    }

    void __clamp__()
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      const AmclConfig &__max__ = __getMax__();
      const AmclConfig &__min__ = __getMin__();
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); ++i)
        (*i)->clamp(*this, __max__, __min__);
    }

    uint32_t __level__(const AmclConfig &config) const
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      uint32_t level = 0;
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); ++i)
        (*i)->calcLevel(level, config, *this);
      return level;
    }

    static const dynamic_reconfigure::ConfigDescription &__getDescriptionMessage__();
    static const AmclConfig &__getDefault__();
    static const AmclConfig &__getMax__();
    static const AmclConfig &__getMin__();
    static const std::vector<AbstractParamDescriptionConstPtr> &__getParamDescriptions__();
    static const std::vector<AbstractGroupDescriptionConstPtr> &__getGroupDescriptions__();

  private:
    static const AmclConfigStatics *__get_statics__();
  };

  template <> // Max and min are ignored for strings.
  inline void AmclConfig::ParamDescription<std::string>::clamp(AmclConfig &config, const AmclConfig &max, const AmclConfig &min) const
  {
    (void) config;
    (void) min;
    (void) max;
    return;
  }

  class AmclConfigStatics
  {
    friend class AmclConfig;

    AmclConfigStatics()
    {
AmclConfig::GroupDescription<AmclConfig::DEFAULT, AmclConfig> Default("Default", "", 0, 0, true, &AmclConfig::groups);
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.global_frame_id = "";
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.global_frame_id = "";
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.global_frame_id = "map";
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(AmclConfig::AbstractParamDescriptionConstPtr(new AmclConfig::ParamDescription<std::string>("global_frame_id", "str", 0, "The name of the coordinate frame published by the localization system.", "", &AmclConfig::global_frame_id)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(AmclConfig::AbstractParamDescriptionConstPtr(new AmclConfig::ParamDescription<std::string>("global_frame_id", "str", 0, "The name of the coordinate frame published by the localization system.", "", &AmclConfig::global_frame_id)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.odom_frame_id = "";
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.odom_frame_id = "";
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.odom_frame_id = "odom";
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(AmclConfig::AbstractParamDescriptionConstPtr(new AmclConfig::ParamDescription<std::string>("odom_frame_id", "str", 0, "The name of the coordinate frame to use for odometry.", "", &AmclConfig::odom_frame_id)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(AmclConfig::AbstractParamDescriptionConstPtr(new AmclConfig::ParamDescription<std::string>("odom_frame_id", "str", 0, "The name of the coordinate frame to use for odometry.", "", &AmclConfig::odom_frame_id)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.base_frame_id = "";
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.base_frame_id = "";
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.base_frame_id = "base_link";
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(AmclConfig::AbstractParamDescriptionConstPtr(new AmclConfig::ParamDescription<std::string>("base_frame_id", "str", 0, "The name of the coordinate frame to use for the robot base.", "", &AmclConfig::base_frame_id)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(AmclConfig::AbstractParamDescriptionConstPtr(new AmclConfig::ParamDescription<std::string>("base_frame_id", "str", 0, "The name of the coordinate frame to use for the robot base.", "", &AmclConfig::base_frame_id)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.map_topic = "";
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.map_topic = "";
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.map_topic = "map";
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(AmclConfig::AbstractParamDescriptionConstPtr(new AmclConfig::ParamDescription<std::string>("map_topic", "str", 0, "Topic to subscribe to in order to receive the map to localize on.", "", &AmclConfig::map_topic)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(AmclConfig::AbstractParamDescriptionConstPtr(new AmclConfig::ParamDescription<std::string>("map_topic", "str", 0, "Topic to subscribe to in order to receive the map to localize on.", "", &AmclConfig::map_topic)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.map_service = "";
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.map_service = "";
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.map_service = "static_map";
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(AmclConfig::AbstractParamDescriptionConstPtr(new AmclConfig::ParamDescription<std::string>("map_service", "str", 0, "Service to call to get the map to localize on.", "", &AmclConfig::map_service)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(AmclConfig::AbstractParamDescriptionConstPtr(new AmclConfig::ParamDescription<std::string>("map_service", "str", 0, "Service to call to get the map to localize on.", "", &AmclConfig::map_service)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.use_map_topic = 0;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.use_map_topic = 1;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.use_map_topic = 1;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(AmclConfig::AbstractParamDescriptionConstPtr(new AmclConfig::ParamDescription<bool>("use_map_topic", "bool", 0, "Whether to subscribe to the map topic or call the map service to get a map to localize on.", "", &AmclConfig::use_map_topic)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(AmclConfig::AbstractParamDescriptionConstPtr(new AmclConfig::ParamDescription<bool>("use_map_topic", "bool", 0, "Whether to subscribe to the map topic or call the map service to get a map to localize on.", "", &AmclConfig::use_map_topic)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.initial_pose_topic = "";
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.initial_pose_topic = "";
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.initial_pose_topic = "initialpose";
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(AmclConfig::AbstractParamDescriptionConstPtr(new AmclConfig::ParamDescription<std::string>("initial_pose_topic", "str", 0, "Topic to subscribe to in order to receive the initial pose of the robot.", "", &AmclConfig::initial_pose_topic)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(AmclConfig::AbstractParamDescriptionConstPtr(new AmclConfig::ParamDescription<std::string>("initial_pose_topic", "str", 0, "Topic to subscribe to in order to receive the initial pose of the robot.", "", &AmclConfig::initial_pose_topic)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.scan_topic = "";
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.scan_topic = "";
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.scan_topic = "scan";
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(AmclConfig::AbstractParamDescriptionConstPtr(new AmclConfig::ParamDescription<std::string>("scan_topic", "str", 0, "Topic to subscribe to in order to receive the laser scan for localization.", "", &AmclConfig::scan_topic)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(AmclConfig::AbstractParamDescriptionConstPtr(new AmclConfig::ParamDescription<std::string>("scan_topic", "str", 0, "Topic to subscribe to in order to receive the laser scan for localization.", "", &AmclConfig::scan_topic)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.min_particles = 0;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.min_particles = 2147483647;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.min_particles = 100;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(AmclConfig::AbstractParamDescriptionConstPtr(new AmclConfig::ParamDescription<int>("min_particles", "int", 0, "Minimum allowed number of particles.", "", &AmclConfig::min_particles)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(AmclConfig::AbstractParamDescriptionConstPtr(new AmclConfig::ParamDescription<int>("min_particles", "int", 0, "Minimum allowed number of particles.", "", &AmclConfig::min_particles)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.max_particles = 0;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.max_particles = 2147483647;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.max_particles = 5000;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(AmclConfig::AbstractParamDescriptionConstPtr(new AmclConfig::ParamDescription<int>("max_particles", "int", 0, "Maximum allowed number of particles.", "", &AmclConfig::max_particles)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(AmclConfig::AbstractParamDescriptionConstPtr(new AmclConfig::ParamDescription<int>("max_particles", "int", 0, "Maximum allowed number of particles.", "", &AmclConfig::max_particles)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.recovery_alpha_slow = 0.0;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.recovery_alpha_slow = 1.0;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.recovery_alpha_slow = 0.001;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(AmclConfig::AbstractParamDescriptionConstPtr(new AmclConfig::ParamDescription<double>("recovery_alpha_slow", "double", 0, "Exponential decay rate for the slow average weight filter, used in deciding when to recover by adding random poses.", "", &AmclConfig::recovery_alpha_slow)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(AmclConfig::AbstractParamDescriptionConstPtr(new AmclConfig::ParamDescription<double>("recovery_alpha_slow", "double", 0, "Exponential decay rate for the slow average weight filter, used in deciding when to recover by adding random poses.", "", &AmclConfig::recovery_alpha_slow)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.recovery_alpha_fast = 0.0;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.recovery_alpha_fast = 1.0;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.recovery_alpha_fast = 0.1;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(AmclConfig::AbstractParamDescriptionConstPtr(new AmclConfig::ParamDescription<double>("recovery_alpha_fast", "double", 0, "Exponential decay rate for the fast average weight filter, used in deciding when to recover by adding random poses.", "", &AmclConfig::recovery_alpha_fast)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(AmclConfig::AbstractParamDescriptionConstPtr(new AmclConfig::ParamDescription<double>("recovery_alpha_fast", "double", 0, "Exponential decay rate for the fast average weight filter, used in deciding when to recover by adding random poses.", "", &AmclConfig::recovery_alpha_fast)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.kld_err = 0.0;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.kld_err = 1.0;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.kld_err = 0.01;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(AmclConfig::AbstractParamDescriptionConstPtr(new AmclConfig::ParamDescription<double>("kld_err", "double", 0, "Maximum particle filter population error between the true distribution and the estimated distribution. It is used in KLD resampling to limit the allowed number of particles to the minimum necessary.", "", &AmclConfig::kld_err)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(AmclConfig::AbstractParamDescriptionConstPtr(new AmclConfig::ParamDescription<double>("kld_err", "double", 0, "Maximum particle filter population error between the true distribution and the estimated distribution. It is used in KLD resampling to limit the allowed number of particles to the minimum necessary.", "", &AmclConfig::kld_err)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.kld_z = -std::numeric_limits<double>::infinity();
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.kld_z = std::numeric_limits<double>::infinity();
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.kld_z = 0.99;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(AmclConfig::AbstractParamDescriptionConstPtr(new AmclConfig::ParamDescription<double>("kld_z", "double", 0, "Upper standard normal quantile for P, where P is the probability that the error in the estimated distribution will be less than pf_err in KLD resampling.", "", &AmclConfig::kld_z)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(AmclConfig::AbstractParamDescriptionConstPtr(new AmclConfig::ParamDescription<double>("kld_z", "double", 0, "Upper standard normal quantile for P, where P is the probability that the error in the estimated distribution will be less than pf_err in KLD resampling.", "", &AmclConfig::kld_z)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.spatial_resolution_x = 0.0;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.spatial_resolution_x = std::numeric_limits<double>::infinity();
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.spatial_resolution_x = 0.5;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(AmclConfig::AbstractParamDescriptionConstPtr(new AmclConfig::ParamDescription<double>("spatial_resolution_x", "double", 0, "Resolution in meters for the X axis used to divide the space in buckets for KLD resampling.", "", &AmclConfig::spatial_resolution_x)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(AmclConfig::AbstractParamDescriptionConstPtr(new AmclConfig::ParamDescription<double>("spatial_resolution_x", "double", 0, "Resolution in meters for the X axis used to divide the space in buckets for KLD resampling.", "", &AmclConfig::spatial_resolution_x)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.spatial_resolution_y = 0.0;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.spatial_resolution_y = std::numeric_limits<double>::infinity();
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.spatial_resolution_y = 0.5;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(AmclConfig::AbstractParamDescriptionConstPtr(new AmclConfig::ParamDescription<double>("spatial_resolution_y", "double", 0, "Resolution in meters for the Y axis used to divide the space in buckets for KLD resampling.", "", &AmclConfig::spatial_resolution_y)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(AmclConfig::AbstractParamDescriptionConstPtr(new AmclConfig::ParamDescription<double>("spatial_resolution_y", "double", 0, "Resolution in meters for the Y axis used to divide the space in buckets for KLD resampling.", "", &AmclConfig::spatial_resolution_y)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.spatial_resolution_theta = 0.0;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.spatial_resolution_theta = 6.283185307179586;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.spatial_resolution_theta = 0.17453292519943295;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(AmclConfig::AbstractParamDescriptionConstPtr(new AmclConfig::ParamDescription<double>("spatial_resolution_theta", "double", 0, "Resolution in radians for the theta axis to divide the space in buckets for KLD resampling.", "", &AmclConfig::spatial_resolution_theta)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(AmclConfig::AbstractParamDescriptionConstPtr(new AmclConfig::ParamDescription<double>("spatial_resolution_theta", "double", 0, "Resolution in radians for the theta axis to divide the space in buckets for KLD resampling.", "", &AmclConfig::spatial_resolution_theta)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.resample_interval = 1;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.resample_interval = 2147483647;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.resample_interval = 2;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(AmclConfig::AbstractParamDescriptionConstPtr(new AmclConfig::ParamDescription<int>("resample_interval", "int", 0, "Number of filter updates required before resampling.", "", &AmclConfig::resample_interval)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(AmclConfig::AbstractParamDescriptionConstPtr(new AmclConfig::ParamDescription<int>("resample_interval", "int", 0, "Number of filter updates required before resampling.", "", &AmclConfig::resample_interval)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.selective_resampling = 0;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.selective_resampling = 1;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.selective_resampling = 0;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(AmclConfig::AbstractParamDescriptionConstPtr(new AmclConfig::ParamDescription<bool>("selective_resampling", "bool", 0, "When set to true, will reduce the resampling rate when not needed and help avoid particle deprivation. The resampling will only happen if the effective number of particles (N_eff = 1/(sum(k_i^2))) is lower than half the current number of particles (READ-ONLY).", "", &AmclConfig::selective_resampling)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(AmclConfig::AbstractParamDescriptionConstPtr(new AmclConfig::ParamDescription<bool>("selective_resampling", "bool", 0, "When set to true, will reduce the resampling rate when not needed and help avoid particle deprivation. The resampling will only happen if the effective number of particles (N_eff = 1/(sum(k_i^2))) is lower than half the current number of particles (READ-ONLY).", "", &AmclConfig::selective_resampling)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.tf_broadcast = 0;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.tf_broadcast = 1;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.tf_broadcast = 1;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(AmclConfig::AbstractParamDescriptionConstPtr(new AmclConfig::ParamDescription<bool>("tf_broadcast", "bool", 0, "Set this to false to prevent amcl from publishing the transform between the global frame and the odometry frame.", "", &AmclConfig::tf_broadcast)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(AmclConfig::AbstractParamDescriptionConstPtr(new AmclConfig::ParamDescription<bool>("tf_broadcast", "bool", 0, "Set this to false to prevent amcl from publishing the transform between the global frame and the odometry frame.", "", &AmclConfig::tf_broadcast)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.transform_tolerance = 0.0;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.transform_tolerance = std::numeric_limits<double>::infinity();
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.transform_tolerance = 0.1;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(AmclConfig::AbstractParamDescriptionConstPtr(new AmclConfig::ParamDescription<double>("transform_tolerance", "double", 0, "Time with which to post-date the transform that is published, to indicate that this transform is valid into the future", "", &AmclConfig::transform_tolerance)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(AmclConfig::AbstractParamDescriptionConstPtr(new AmclConfig::ParamDescription<double>("transform_tolerance", "double", 0, "Time with which to post-date the transform that is published, to indicate that this transform is valid into the future", "", &AmclConfig::transform_tolerance)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.odom_model_type = "";
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.odom_model_type = "";
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.odom_model_type = "differential_drive";
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(AmclConfig::AbstractParamDescriptionConstPtr(new AmclConfig::ParamDescription<std::string>("odom_model_type", "str", 0, "Which motion model to use", "{'enum': [{'name': 'differential_drive', 'type': 'str', 'value': 'differential_drive', 'srcline': 166, 'srcfile': '/tmp/binarydeb/ros-noetic-beluga-amcl-2.0.2/config/Amcl.cfg', 'description': '', 'ctype': 'std::string', 'cconsttype': 'const char * const'}, {'name': 'omnidirectional_drive', 'type': 'str', 'value': 'omnidirectional_drive', 'srcline': 167, 'srcfile': '/tmp/binarydeb/ros-noetic-beluga-amcl-2.0.2/config/Amcl.cfg', 'description': '', 'ctype': 'std::string', 'cconsttype': 'const char * const'}, {'name': 'stationary', 'type': 'str', 'value': 'stationary', 'srcline': 168, 'srcfile': '/tmp/binarydeb/ros-noetic-beluga-amcl-2.0.2/config/Amcl.cfg', 'description': '', 'ctype': 'std::string', 'cconsttype': 'const char * const'}], 'enum_description': 'Motion models supported'}", &AmclConfig::odom_model_type)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(AmclConfig::AbstractParamDescriptionConstPtr(new AmclConfig::ParamDescription<std::string>("odom_model_type", "str", 0, "Which motion model to use", "{'enum': [{'name': 'differential_drive', 'type': 'str', 'value': 'differential_drive', 'srcline': 166, 'srcfile': '/tmp/binarydeb/ros-noetic-beluga-amcl-2.0.2/config/Amcl.cfg', 'description': '', 'ctype': 'std::string', 'cconsttype': 'const char * const'}, {'name': 'omnidirectional_drive', 'type': 'str', 'value': 'omnidirectional_drive', 'srcline': 167, 'srcfile': '/tmp/binarydeb/ros-noetic-beluga-amcl-2.0.2/config/Amcl.cfg', 'description': '', 'ctype': 'std::string', 'cconsttype': 'const char * const'}, {'name': 'stationary', 'type': 'str', 'value': 'stationary', 'srcline': 168, 'srcfile': '/tmp/binarydeb/ros-noetic-beluga-amcl-2.0.2/config/Amcl.cfg', 'description': '', 'ctype': 'std::string', 'cconsttype': 'const char * const'}], 'enum_description': 'Motion models supported'}", &AmclConfig::odom_model_type)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.odom_alpha1 = 0.0;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.odom_alpha1 = std::numeric_limits<double>::infinity();
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.odom_alpha1 = 0.2;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(AmclConfig::AbstractParamDescriptionConstPtr(new AmclConfig::ParamDescription<double>("odom_alpha1", "double", 0, "Rotation noise from rotation for the differential drive model.", "", &AmclConfig::odom_alpha1)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(AmclConfig::AbstractParamDescriptionConstPtr(new AmclConfig::ParamDescription<double>("odom_alpha1", "double", 0, "Rotation noise from rotation for the differential drive model.", "", &AmclConfig::odom_alpha1)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.odom_alpha2 = 0.0;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.odom_alpha2 = std::numeric_limits<double>::infinity();
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.odom_alpha2 = 0.2;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(AmclConfig::AbstractParamDescriptionConstPtr(new AmclConfig::ParamDescription<double>("odom_alpha2", "double", 0, "Rotation noise from translation for the differential drive model.", "", &AmclConfig::odom_alpha2)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(AmclConfig::AbstractParamDescriptionConstPtr(new AmclConfig::ParamDescription<double>("odom_alpha2", "double", 0, "Rotation noise from translation for the differential drive model.", "", &AmclConfig::odom_alpha2)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.odom_alpha3 = 0.0;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.odom_alpha3 = std::numeric_limits<double>::infinity();
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.odom_alpha3 = 0.2;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(AmclConfig::AbstractParamDescriptionConstPtr(new AmclConfig::ParamDescription<double>("odom_alpha3", "double", 0, "Translation noise from translation for the differential drive model.", "", &AmclConfig::odom_alpha3)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(AmclConfig::AbstractParamDescriptionConstPtr(new AmclConfig::ParamDescription<double>("odom_alpha3", "double", 0, "Translation noise from translation for the differential drive model.", "", &AmclConfig::odom_alpha3)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.odom_alpha4 = 0.0;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.odom_alpha4 = std::numeric_limits<double>::infinity();
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.odom_alpha4 = 0.2;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(AmclConfig::AbstractParamDescriptionConstPtr(new AmclConfig::ParamDescription<double>("odom_alpha4", "double", 0, "Translation noise from rotation for the differential drive model.", "", &AmclConfig::odom_alpha4)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(AmclConfig::AbstractParamDescriptionConstPtr(new AmclConfig::ParamDescription<double>("odom_alpha4", "double", 0, "Translation noise from rotation for the differential drive model.", "", &AmclConfig::odom_alpha4)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.odom_alpha5 = 0.0;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.odom_alpha5 = std::numeric_limits<double>::infinity();
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.odom_alpha5 = 0.2;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(AmclConfig::AbstractParamDescriptionConstPtr(new AmclConfig::ParamDescription<double>("odom_alpha5", "double", 0, "Strafe noise from translation for the omnidirectional drive model.", "", &AmclConfig::odom_alpha5)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(AmclConfig::AbstractParamDescriptionConstPtr(new AmclConfig::ParamDescription<double>("odom_alpha5", "double", 0, "Strafe noise from translation for the omnidirectional drive model.", "", &AmclConfig::odom_alpha5)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.update_min_a = 0.0;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.update_min_a = 6.283185307179586;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.update_min_a = 0.5235987755982988;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(AmclConfig::AbstractParamDescriptionConstPtr(new AmclConfig::ParamDescription<double>("update_min_a", "double", 0, "Rotational movement required before performing a filter update.", "", &AmclConfig::update_min_a)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(AmclConfig::AbstractParamDescriptionConstPtr(new AmclConfig::ParamDescription<double>("update_min_a", "double", 0, "Rotational movement required before performing a filter update.", "", &AmclConfig::update_min_a)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.update_min_d = 0.0;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.update_min_d = std::numeric_limits<double>::infinity();
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.update_min_d = 0.2;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(AmclConfig::AbstractParamDescriptionConstPtr(new AmclConfig::ParamDescription<double>("update_min_d", "double", 0, "Translational movement required before performing a filter update.", "", &AmclConfig::update_min_d)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(AmclConfig::AbstractParamDescriptionConstPtr(new AmclConfig::ParamDescription<double>("update_min_d", "double", 0, "Translational movement required before performing a filter update.", "", &AmclConfig::update_min_d)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.laser_model_type = "";
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.laser_model_type = "";
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.laser_model_type = "likelihood_field";
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(AmclConfig::AbstractParamDescriptionConstPtr(new AmclConfig::ParamDescription<std::string>("laser_model_type", "str", 0, "Which observation model to use.", "{'enum': [{'name': 'beam', 'type': 'str', 'value': 'beam', 'srcline': 219, 'srcfile': '/tmp/binarydeb/ros-noetic-beluga-amcl-2.0.2/config/Amcl.cfg', 'description': '', 'ctype': 'std::string', 'cconsttype': 'const char * const'}, {'name': 'likelihood_field', 'type': 'str', 'value': 'likelihood_field', 'srcline': 220, 'srcfile': '/tmp/binarydeb/ros-noetic-beluga-amcl-2.0.2/config/Amcl.cfg', 'description': '', 'ctype': 'std::string', 'cconsttype': 'const char * const'}], 'enum_description': 'Sensor models supported.'}", &AmclConfig::laser_model_type)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(AmclConfig::AbstractParamDescriptionConstPtr(new AmclConfig::ParamDescription<std::string>("laser_model_type", "str", 0, "Which observation model to use.", "{'enum': [{'name': 'beam', 'type': 'str', 'value': 'beam', 'srcline': 219, 'srcfile': '/tmp/binarydeb/ros-noetic-beluga-amcl-2.0.2/config/Amcl.cfg', 'description': '', 'ctype': 'std::string', 'cconsttype': 'const char * const'}, {'name': 'likelihood_field', 'type': 'str', 'value': 'likelihood_field', 'srcline': 220, 'srcfile': '/tmp/binarydeb/ros-noetic-beluga-amcl-2.0.2/config/Amcl.cfg', 'description': '', 'ctype': 'std::string', 'cconsttype': 'const char * const'}], 'enum_description': 'Sensor models supported.'}", &AmclConfig::laser_model_type)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.laser_likelihood_max_dist = 0.0;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.laser_likelihood_max_dist = std::numeric_limits<double>::infinity();
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.laser_likelihood_max_dist = 2.0;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(AmclConfig::AbstractParamDescriptionConstPtr(new AmclConfig::ParamDescription<double>("laser_likelihood_max_dist", "double", 0, "Maximum distance to do obstacle inflation on map, used in likelihood field model.", "", &AmclConfig::laser_likelihood_max_dist)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(AmclConfig::AbstractParamDescriptionConstPtr(new AmclConfig::ParamDescription<double>("laser_likelihood_max_dist", "double", 0, "Maximum distance to do obstacle inflation on map, used in likelihood field model.", "", &AmclConfig::laser_likelihood_max_dist)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.laser_max_range = 0.0;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.laser_max_range = std::numeric_limits<double>::infinity();
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.laser_max_range = 100.0;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(AmclConfig::AbstractParamDescriptionConstPtr(new AmclConfig::ParamDescription<double>("laser_max_range", "double", 0, "Maximum scan range to be considered.", "", &AmclConfig::laser_max_range)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(AmclConfig::AbstractParamDescriptionConstPtr(new AmclConfig::ParamDescription<double>("laser_max_range", "double", 0, "Maximum scan range to be considered.", "", &AmclConfig::laser_max_range)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.laser_min_range = 0.0;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.laser_min_range = std::numeric_limits<double>::infinity();
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.laser_min_range = 0.0;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(AmclConfig::AbstractParamDescriptionConstPtr(new AmclConfig::ParamDescription<double>("laser_min_range", "double", 0, "Minimum scan range to be considered.", "", &AmclConfig::laser_min_range)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(AmclConfig::AbstractParamDescriptionConstPtr(new AmclConfig::ParamDescription<double>("laser_min_range", "double", 0, "Minimum scan range to be considered.", "", &AmclConfig::laser_min_range)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.laser_max_beams = 2;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.laser_max_beams = 2147483647;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.laser_max_beams = 30;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(AmclConfig::AbstractParamDescriptionConstPtr(new AmclConfig::ParamDescription<int>("laser_max_beams", "int", 0, "How many evenly-spaced beams in each scan will be used when updating the filter.", "", &AmclConfig::laser_max_beams)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(AmclConfig::AbstractParamDescriptionConstPtr(new AmclConfig::ParamDescription<int>("laser_max_beams", "int", 0, "How many evenly-spaced beams in each scan will be used when updating the filter.", "", &AmclConfig::laser_max_beams)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.laser_z_hit = 0.0;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.laser_z_hit = 1.0;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.laser_z_hit = 0.95;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(AmclConfig::AbstractParamDescriptionConstPtr(new AmclConfig::ParamDescription<double>("laser_z_hit", "double", 0, "Mixture weight for the probability of hitting an obstacle.", "", &AmclConfig::laser_z_hit)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(AmclConfig::AbstractParamDescriptionConstPtr(new AmclConfig::ParamDescription<double>("laser_z_hit", "double", 0, "Mixture weight for the probability of hitting an obstacle.", "", &AmclConfig::laser_z_hit)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.laser_z_rand = 0.0;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.laser_z_rand = 1.0;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.laser_z_rand = 0.05;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(AmclConfig::AbstractParamDescriptionConstPtr(new AmclConfig::ParamDescription<double>("laser_z_rand", "double", 0, "Mixture weight for the probability of getting random measurements.", "", &AmclConfig::laser_z_rand)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(AmclConfig::AbstractParamDescriptionConstPtr(new AmclConfig::ParamDescription<double>("laser_z_rand", "double", 0, "Mixture weight for the probability of getting random measurements.", "", &AmclConfig::laser_z_rand)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.laser_z_max = 0.0;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.laser_z_max = 1.0;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.laser_z_max = 0.05;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(AmclConfig::AbstractParamDescriptionConstPtr(new AmclConfig::ParamDescription<double>("laser_z_max", "double", 0, "Mixture weight for the probability of getting max range measurements.", "", &AmclConfig::laser_z_max)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(AmclConfig::AbstractParamDescriptionConstPtr(new AmclConfig::ParamDescription<double>("laser_z_max", "double", 0, "Mixture weight for the probability of getting max range measurements.", "", &AmclConfig::laser_z_max)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.laser_z_short = 0.0;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.laser_z_short = 1.0;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.laser_z_short = 0.1;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(AmclConfig::AbstractParamDescriptionConstPtr(new AmclConfig::ParamDescription<double>("laser_z_short", "double", 0, "Mixture weight for the probability of getting short measurements.", "", &AmclConfig::laser_z_short)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(AmclConfig::AbstractParamDescriptionConstPtr(new AmclConfig::ParamDescription<double>("laser_z_short", "double", 0, "Mixture weight for the probability of getting short measurements.", "", &AmclConfig::laser_z_short)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.laser_lambda_short = 0.0;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.laser_lambda_short = std::numeric_limits<double>::infinity();
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.laser_lambda_short = 0.1;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(AmclConfig::AbstractParamDescriptionConstPtr(new AmclConfig::ParamDescription<double>("laser_lambda_short", "double", 0, "Short readings' exponential distribution parameter.", "", &AmclConfig::laser_lambda_short)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(AmclConfig::AbstractParamDescriptionConstPtr(new AmclConfig::ParamDescription<double>("laser_lambda_short", "double", 0, "Short readings' exponential distribution parameter.", "", &AmclConfig::laser_lambda_short)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.laser_sigma_hit = 0.0;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.laser_sigma_hit = std::numeric_limits<double>::infinity();
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.laser_sigma_hit = 0.2;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(AmclConfig::AbstractParamDescriptionConstPtr(new AmclConfig::ParamDescription<double>("laser_sigma_hit", "double", 0, "Standard deviation of the hit distribution.", "", &AmclConfig::laser_sigma_hit)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(AmclConfig::AbstractParamDescriptionConstPtr(new AmclConfig::ParamDescription<double>("laser_sigma_hit", "double", 0, "Standard deviation of the hit distribution.", "", &AmclConfig::laser_sigma_hit)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.always_reset_initial_pose = 0;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.always_reset_initial_pose = 1;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.always_reset_initial_pose = 0;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(AmclConfig::AbstractParamDescriptionConstPtr(new AmclConfig::ParamDescription<bool>("always_reset_initial_pose", "bool", 0, "If false, AMCL will use the last known pose to initialize when a new map is received.", "", &AmclConfig::always_reset_initial_pose)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(AmclConfig::AbstractParamDescriptionConstPtr(new AmclConfig::ParamDescription<bool>("always_reset_initial_pose", "bool", 0, "If false, AMCL will use the last known pose to initialize when a new map is received.", "", &AmclConfig::always_reset_initial_pose)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.first_map_only = 0;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.first_map_only = 1;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.first_map_only = 0;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(AmclConfig::AbstractParamDescriptionConstPtr(new AmclConfig::ParamDescription<bool>("first_map_only", "bool", 0, "Set this to true when you want to load only the first published map from map_server and ignore subsequent ones.", "", &AmclConfig::first_map_only)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(AmclConfig::AbstractParamDescriptionConstPtr(new AmclConfig::ParamDescription<bool>("first_map_only", "bool", 0, "Set this to true when you want to load only the first published map from map_server and ignore subsequent ones.", "", &AmclConfig::first_map_only)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.set_initial_pose = 0;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.set_initial_pose = 1;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.set_initial_pose = 0;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(AmclConfig::AbstractParamDescriptionConstPtr(new AmclConfig::ParamDescription<bool>("set_initial_pose", "bool", 0, "Set the initial pose from the initial_pose parameters.", "", &AmclConfig::set_initial_pose)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(AmclConfig::AbstractParamDescriptionConstPtr(new AmclConfig::ParamDescription<bool>("set_initial_pose", "bool", 0, "Set the initial pose from the initial_pose parameters.", "", &AmclConfig::set_initial_pose)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.initial_pose_x = -std::numeric_limits<double>::infinity();
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.initial_pose_x = std::numeric_limits<double>::infinity();
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.initial_pose_x = 0.0;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(AmclConfig::AbstractParamDescriptionConstPtr(new AmclConfig::ParamDescription<double>("initial_pose_x", "double", 0.0, "Initial pose x axis coordinate.", "", &AmclConfig::initial_pose_x)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(AmclConfig::AbstractParamDescriptionConstPtr(new AmclConfig::ParamDescription<double>("initial_pose_x", "double", 0.0, "Initial pose x axis coordinate.", "", &AmclConfig::initial_pose_x)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.initial_pose_y = -std::numeric_limits<double>::infinity();
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.initial_pose_y = std::numeric_limits<double>::infinity();
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.initial_pose_y = 0.0;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(AmclConfig::AbstractParamDescriptionConstPtr(new AmclConfig::ParamDescription<double>("initial_pose_y", "double", 0.0, "Initial pose y axis coordinate.", "", &AmclConfig::initial_pose_y)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(AmclConfig::AbstractParamDescriptionConstPtr(new AmclConfig::ParamDescription<double>("initial_pose_y", "double", 0.0, "Initial pose y axis coordinate.", "", &AmclConfig::initial_pose_y)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.initial_pose_a = -std::numeric_limits<double>::infinity();
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.initial_pose_a = std::numeric_limits<double>::infinity();
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.initial_pose_a = 0.0;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(AmclConfig::AbstractParamDescriptionConstPtr(new AmclConfig::ParamDescription<double>("initial_pose_a", "double", 0.0, "Initial pose yaw rotation.", "", &AmclConfig::initial_pose_a)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(AmclConfig::AbstractParamDescriptionConstPtr(new AmclConfig::ParamDescription<double>("initial_pose_a", "double", 0.0, "Initial pose yaw rotation.", "", &AmclConfig::initial_pose_a)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.initial_cov_xx = -std::numeric_limits<double>::infinity();
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.initial_cov_xx = std::numeric_limits<double>::infinity();
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.initial_cov_xx = 0.0;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(AmclConfig::AbstractParamDescriptionConstPtr(new AmclConfig::ParamDescription<double>("initial_cov_xx", "double", 0, "Initial pose x axis covariance.", "", &AmclConfig::initial_cov_xx)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(AmclConfig::AbstractParamDescriptionConstPtr(new AmclConfig::ParamDescription<double>("initial_cov_xx", "double", 0, "Initial pose x axis covariance.", "", &AmclConfig::initial_cov_xx)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.initial_cov_yy = -std::numeric_limits<double>::infinity();
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.initial_cov_yy = std::numeric_limits<double>::infinity();
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.initial_cov_yy = 0.0;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(AmclConfig::AbstractParamDescriptionConstPtr(new AmclConfig::ParamDescription<double>("initial_cov_yy", "double", 0, "Initial pose y axis covariance.", "", &AmclConfig::initial_cov_yy)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(AmclConfig::AbstractParamDescriptionConstPtr(new AmclConfig::ParamDescription<double>("initial_cov_yy", "double", 0, "Initial pose y axis covariance.", "", &AmclConfig::initial_cov_yy)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.initial_cov_aa = -std::numeric_limits<double>::infinity();
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.initial_cov_aa = std::numeric_limits<double>::infinity();
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.initial_cov_aa = 0.0;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(AmclConfig::AbstractParamDescriptionConstPtr(new AmclConfig::ParamDescription<double>("initial_cov_aa", "double", 0, "Initial pose yaw covariance.", "", &AmclConfig::initial_cov_aa)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(AmclConfig::AbstractParamDescriptionConstPtr(new AmclConfig::ParamDescription<double>("initial_cov_aa", "double", 0, "Initial pose yaw covariance.", "", &AmclConfig::initial_cov_aa)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.initial_cov_xy = -std::numeric_limits<double>::infinity();
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.initial_cov_xy = std::numeric_limits<double>::infinity();
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.initial_cov_xy = 0.0;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(AmclConfig::AbstractParamDescriptionConstPtr(new AmclConfig::ParamDescription<double>("initial_cov_xy", "double", 0, "Initial pose xy covariance.", "", &AmclConfig::initial_cov_xy)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(AmclConfig::AbstractParamDescriptionConstPtr(new AmclConfig::ParamDescription<double>("initial_cov_xy", "double", 0, "Initial pose xy covariance.", "", &AmclConfig::initial_cov_xy)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.initial_cov_xa = -std::numeric_limits<double>::infinity();
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.initial_cov_xa = std::numeric_limits<double>::infinity();
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.initial_cov_xa = 0.0;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(AmclConfig::AbstractParamDescriptionConstPtr(new AmclConfig::ParamDescription<double>("initial_cov_xa", "double", 0, "Initial pose xyaw covariance.", "", &AmclConfig::initial_cov_xa)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(AmclConfig::AbstractParamDescriptionConstPtr(new AmclConfig::ParamDescription<double>("initial_cov_xa", "double", 0, "Initial pose xyaw covariance.", "", &AmclConfig::initial_cov_xa)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.initial_cov_ya = -std::numeric_limits<double>::infinity();
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.initial_cov_ya = std::numeric_limits<double>::infinity();
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.initial_cov_ya = 0.0;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(AmclConfig::AbstractParamDescriptionConstPtr(new AmclConfig::ParamDescription<double>("initial_cov_ya", "double", 0, "Initial pose yyaw covariance.", "", &AmclConfig::initial_cov_ya)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(AmclConfig::AbstractParamDescriptionConstPtr(new AmclConfig::ParamDescription<double>("initial_cov_ya", "double", 0, "Initial pose yyaw covariance.", "", &AmclConfig::initial_cov_ya)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.save_pose_rate = -std::numeric_limits<double>::infinity();
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.save_pose_rate = std::numeric_limits<double>::infinity();
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.save_pose_rate = 0.5;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(AmclConfig::AbstractParamDescriptionConstPtr(new AmclConfig::ParamDescription<double>("save_pose_rate", "double", 0, "Rate at which to store the last estimated pose and covariance to the parameter server.", "", &AmclConfig::save_pose_rate)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(AmclConfig::AbstractParamDescriptionConstPtr(new AmclConfig::ParamDescription<double>("save_pose_rate", "double", 0, "Rate at which to store the last estimated pose and covariance to the parameter server.", "", &AmclConfig::save_pose_rate)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.execution_policy = "";
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.execution_policy = "";
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.execution_policy = "seq";
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(AmclConfig::AbstractParamDescriptionConstPtr(new AmclConfig::ParamDescription<std::string>("execution_policy", "str", 0, "Execution policy used to process particles.", "{'enum': [{'name': 'seq', 'type': 'str', 'value': 'seq', 'srcline': 364, 'srcfile': '/tmp/binarydeb/ros-noetic-beluga-amcl-2.0.2/config/Amcl.cfg', 'description': '', 'ctype': 'std::string', 'cconsttype': 'const char * const'}, {'name': 'par', 'type': 'str', 'value': 'par', 'srcline': 365, 'srcfile': '/tmp/binarydeb/ros-noetic-beluga-amcl-2.0.2/config/Amcl.cfg', 'description': '', 'ctype': 'std::string', 'cconsttype': 'const char * const'}], 'enum_description': 'Execution policies supported.'}", &AmclConfig::execution_policy)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(AmclConfig::AbstractParamDescriptionConstPtr(new AmclConfig::ParamDescription<std::string>("execution_policy", "str", 0, "Execution policy used to process particles.", "{'enum': [{'name': 'seq', 'type': 'str', 'value': 'seq', 'srcline': 364, 'srcfile': '/tmp/binarydeb/ros-noetic-beluga-amcl-2.0.2/config/Amcl.cfg', 'description': '', 'ctype': 'std::string', 'cconsttype': 'const char * const'}, {'name': 'par', 'type': 'str', 'value': 'par', 'srcline': 365, 'srcfile': '/tmp/binarydeb/ros-noetic-beluga-amcl-2.0.2/config/Amcl.cfg', 'description': '', 'ctype': 'std::string', 'cconsttype': 'const char * const'}], 'enum_description': 'Execution policies supported.'}", &AmclConfig::execution_policy)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.std_warn_level_x = -std::numeric_limits<double>::infinity();
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.std_warn_level_x = std::numeric_limits<double>::infinity();
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.std_warn_level_x = 0.2;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(AmclConfig::AbstractParamDescriptionConstPtr(new AmclConfig::ParamDescription<double>("std_warn_level_x", "double", 0, "Warning level for last estimate x standard deviation.", "", &AmclConfig::std_warn_level_x)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(AmclConfig::AbstractParamDescriptionConstPtr(new AmclConfig::ParamDescription<double>("std_warn_level_x", "double", 0, "Warning level for last estimate x standard deviation.", "", &AmclConfig::std_warn_level_x)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.std_warn_level_y = -std::numeric_limits<double>::infinity();
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.std_warn_level_y = std::numeric_limits<double>::infinity();
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.std_warn_level_y = 0.2;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(AmclConfig::AbstractParamDescriptionConstPtr(new AmclConfig::ParamDescription<double>("std_warn_level_y", "double", 0, "Warning level for last estimate y standard deviation.", "", &AmclConfig::std_warn_level_y)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(AmclConfig::AbstractParamDescriptionConstPtr(new AmclConfig::ParamDescription<double>("std_warn_level_y", "double", 0, "Warning level for last estimate y standard deviation.", "", &AmclConfig::std_warn_level_y)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.std_warn_level_yaw = -std::numeric_limits<double>::infinity();
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.std_warn_level_yaw = std::numeric_limits<double>::infinity();
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.std_warn_level_yaw = 0.2;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(AmclConfig::AbstractParamDescriptionConstPtr(new AmclConfig::ParamDescription<double>("std_warn_level_yaw", "double", 0, "Warning level for last estimate yaw standard deviation.", "", &AmclConfig::std_warn_level_yaw)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(AmclConfig::AbstractParamDescriptionConstPtr(new AmclConfig::ParamDescription<double>("std_warn_level_yaw", "double", 0, "Warning level for last estimate yaw standard deviation.", "", &AmclConfig::std_warn_level_yaw)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.restore_defaults = 0;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.restore_defaults = 1;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.restore_defaults = 0;
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(AmclConfig::AbstractParamDescriptionConstPtr(new AmclConfig::ParamDescription<bool>("restore_defaults", "bool", 0, "Restore default configuration.", "", &AmclConfig::restore_defaults)));
//#line 291 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(AmclConfig::AbstractParamDescriptionConstPtr(new AmclConfig::ParamDescription<bool>("restore_defaults", "bool", 0, "Restore default configuration.", "", &AmclConfig::restore_defaults)));
//#line 246 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.convertParams();
//#line 246 "/opt/ros/noetic/lib/python3/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __group_descriptions__.push_back(AmclConfig::AbstractGroupDescriptionConstPtr(new AmclConfig::GroupDescription<AmclConfig::DEFAULT, AmclConfig>(Default)));
//#line 369 "/opt/ros/noetic/share/dynamic_reconfigure/cmake/../templates/ConfigType.h.template"

      for (std::vector<AmclConfig::AbstractGroupDescriptionConstPtr>::const_iterator i = __group_descriptions__.begin(); i != __group_descriptions__.end(); ++i)
      {
        __description_message__.groups.push_back(**i);
      }
      __max__.__toMessage__(__description_message__.max, __param_descriptions__, __group_descriptions__);
      __min__.__toMessage__(__description_message__.min, __param_descriptions__, __group_descriptions__);
      __default__.__toMessage__(__description_message__.dflt, __param_descriptions__, __group_descriptions__);
    }
    std::vector<AmclConfig::AbstractParamDescriptionConstPtr> __param_descriptions__;
    std::vector<AmclConfig::AbstractGroupDescriptionConstPtr> __group_descriptions__;
    AmclConfig __max__;
    AmclConfig __min__;
    AmclConfig __default__;
    dynamic_reconfigure::ConfigDescription __description_message__;

    static const AmclConfigStatics *get_instance()
    {
      // Split this off in a separate function because I know that
      // instance will get initialized the first time get_instance is
      // called, and I am guaranteeing that get_instance gets called at
      // most once.
      static AmclConfigStatics instance;
      return &instance;
    }
  };

  inline const dynamic_reconfigure::ConfigDescription &AmclConfig::__getDescriptionMessage__()
  {
    return __get_statics__()->__description_message__;
  }

  inline const AmclConfig &AmclConfig::__getDefault__()
  {
    return __get_statics__()->__default__;
  }

  inline const AmclConfig &AmclConfig::__getMax__()
  {
    return __get_statics__()->__max__;
  }

  inline const AmclConfig &AmclConfig::__getMin__()
  {
    return __get_statics__()->__min__;
  }

  inline const std::vector<AmclConfig::AbstractParamDescriptionConstPtr> &AmclConfig::__getParamDescriptions__()
  {
    return __get_statics__()->__param_descriptions__;
  }

  inline const std::vector<AmclConfig::AbstractGroupDescriptionConstPtr> &AmclConfig::__getGroupDescriptions__()
  {
    return __get_statics__()->__group_descriptions__;
  }

  inline const AmclConfigStatics *AmclConfig::__get_statics__()
  {
    const static AmclConfigStatics *statics;

    if (statics) // Common case
      return statics;

    boost::mutex::scoped_lock lock(dynamic_reconfigure::__init_mutex__);

    if (statics) // In case we lost a race.
      return statics;

    statics = AmclConfigStatics::get_instance();

    return statics;
  }

//#line 166 "/tmp/binarydeb/ros-noetic-beluga-amcl-2.0.2/config/Amcl.cfg"
      const char * const Amcl_differential_drive = "differential_drive";
//#line 167 "/tmp/binarydeb/ros-noetic-beluga-amcl-2.0.2/config/Amcl.cfg"
      const char * const Amcl_omnidirectional_drive = "omnidirectional_drive";
//#line 168 "/tmp/binarydeb/ros-noetic-beluga-amcl-2.0.2/config/Amcl.cfg"
      const char * const Amcl_stationary = "stationary";
//#line 219 "/tmp/binarydeb/ros-noetic-beluga-amcl-2.0.2/config/Amcl.cfg"
      const char * const Amcl_beam = "beam";
//#line 220 "/tmp/binarydeb/ros-noetic-beluga-amcl-2.0.2/config/Amcl.cfg"
      const char * const Amcl_likelihood_field = "likelihood_field";
//#line 364 "/tmp/binarydeb/ros-noetic-beluga-amcl-2.0.2/config/Amcl.cfg"
      const char * const Amcl_seq = "seq";
//#line 365 "/tmp/binarydeb/ros-noetic-beluga-amcl-2.0.2/config/Amcl.cfg"
      const char * const Amcl_par = "par";
}

#undef DYNAMIC_RECONFIGURE_FINAL

#endif // __AMCLRECONFIGURATOR_H__
